local LibSmooth = LibStub("LibSmoothStatusBar-1.0")
local SmoothBar = {}
ShadowUF:RegisterModule(SmoothBar, "smoothBar", "Smooth Bar")

local supportedBars = {
	'healthBar',
	'powerBar',
	'altPowerBar',
	'druidBar',
	'demonicFuryBar',
	'monkBar',
	'staggerBar',
	'xpBar.xp',
	'xpBar.rep'
}

local function getBar(frame, barName)
	if not frame then
		return nil
	elseif not strfind(barName, '.') then
		return frame[barName]
	else
		for _, key in pairs({ strsplit('.', barName) }) do
			frame = frame[key]
			if not frame then break end
		end
		return frame
	end	
end

function SmoothBar:OnInitialize()
	for _, unit in pairs(ShadowUF.unitList) do
		ShadowUF.db.profile.units[unit].smoothBar = ShadowUF.db.profile.units[unit].smoothBar or { enabled = true }
	end
end

function SmoothBar:OnEnable(frame)
	for _, barName in ipairs(supportedBars) do
		local bar = getBar(frame, barName)
		if bar then
			LibSmooth:SmoothBar(bar)
		end
	end
end

function SmoothBar:OnDisable(frame)
	for _, barName in ipairs(supportedBars) do
		local bar = getBar(frame, barName)
		if bar then
			LibSmooth:ResetBar(bar)
		end
	end
end
